#include <stdio.h>

#define MAX 1000

/*
 * SVID & X/Open
 */
#define	M_E		2.7182818284590452354
#define	M_LOG2E		1.4426950408889634074
#define	M_LOG10E	0.43429448190325182765
#define	M_LN2		0.69314718055994530942
#define	M_LN10		2.30258509299404568402
#define	M_PI		3.14159265358979323846
#define	M_PI_2		1.57079632679489661923
#define	M_PI_4		0.78539816339744830962
#define	M_1_PI		0.31830988618379067154
#define	M_2_PI		0.63661977236758134308
#define	M_2_SQRTPI	1.12837916709551257390
#define	M_SQRT2		1.41421356237309504880
#define	M_SQRT1_2	0.70710678118654752440

double man[MAX];
double sums[MAX];
double con = 1.0L / 1.643933566682L;

void ing(void)
{
  int i,j;
  double in_res, out_res;
  double sum;
  double deg;
  double con = 90.0 / (double)MAX;
  double con1 = 2.0 * M_PI / 360.0;

  /* initialize array */
  man[0] = 0.0;
  for ( i = 1 ; i < MAX ; i++ ) {
    man[i] = con / (double)(i*i);

    printf("%3d %3.16f\n",
	   i,
	   man[i]);
  }

  for ( i = 1 ; i < MAX ; i++ ) {
    sum = 0.0;
    deg = 0.0;

    for ( j = 0 ; j < MAX ; j++ ) {
      sum = man[i] * cos ( deg * con1 );
      deg += con;
    }

    sums[i] = sum;

    printf("r = %4d, sum = %3.16f\n",
           i,
	   sum);

  }

  /* integrate to get inner and outer values */
  for ( i = 1 ; i < MAX ; i++ ) {

    in_res  = 0.0;
    out_res = 0.0;

    for ( j = 0 ; j < i ; j++ ) {
      in_res += man[j];
    }
    for ( j = i ; j < MAX ; j++ ) {
      out_res += man[j];
    }

    printf("i = %3d, in_res = %3.16f, %3.16f out_res = %3.16f\n",
	   i,
	   in_res,
	   in_res * sums[i],
	   out_res );
  }

}


int main()
{
  ing();
  return 0;
}
