#ifndef __points_h__
#define __points_h__

typedef struct point {
  /* the particle number */
  int particle_number;
  /* the points velosity vector */
  double v_x,v_y;
  /* the points location */
  double x,y;
  /* the points mass */
  double mass;
  /* flag */
  int flag;
} POINT, *POINT_PTR;

#define POINT_FLAG_UNIFORCE 8

/* a constant used with 'C' calcuations */
extern double n_const;

/* max points allowed */
#define POINT_MAX 32
extern int pts_idx;
extern POINT pts[POINT_MAX];

/* when drawing on the screen, use this
 * number of pixels
 */
#define POINT_SIZE 1

#ifdef __cplusplus
extern "C" {
#endif

/* draw all points */
void draw_all_points ( void );

/* move a point one tick
 *
 * Returns: TRUE if stays in bounds,
 *          else FALSE
 */
int mover_once ( POINT_PTR p, double tim );

/* show points velosity */
void show_points_vel ( void );

#ifdef __cplusplus
};
#endif

#endif /* __points_h__ */
