/* rad.c */

#include <stdio.h>
#include <math.h>

/*
 * SVID & X/Open
 */
#define	M_E		2.7182818284590452354
#define	M_LOG2E		1.4426950408889634074
#define	M_LOG10E	0.43429448190325182765
#define	M_LN2		0.69314718055994530942
#define	M_LN10		2.30258509299404568402
#define	M_PI		3.14159265358979323846
#define	M_PI_2		1.57079632679489661923
#define	M_PI_4		0.78539816339744830962
#define	M_1_PI		0.31830988618379067154
#define	M_2_PI		0.63661977236758134308
#define	M_2_SQRTPI	1.12837916709551257390
#define	M_SQRT2		1.41421356237309504880
#define	M_SQRT1_2	0.70710678118654752440

/*
 * precompute conversion constants
 * from degrees to cartesian coordinates.
 *
 * To compute x,y, just multiply radius
 * times the constant.
 */

#include "tab.h"

void rad( void )
{
  double k1 = (2.0 * M_PI) / 360.0;
  double res_y;
  double res_x;
  int i;
  char c;

  printf("typedef struct rad { double x; double y; } RAD, *RAD_PTR;\n");

  printf("RAD rads[CIRCS] = {\n");

  for ( i = 0 ; i < CIRCS ; i++ ) {
    res_y = sin ( (double)i * k1 );
    res_x = cos ( (double)i * k1 );

    /* compensate for math errors */
    if ( i == 90 ) {
      res_x = 0.0;
    } else {
      if ( i == 180 ) {
	res_y = 0.0;
      } else {
	if ( i == 270 ) {
	  res_x = 0.0;
	}
      }
    }

    if ( i == 359 ) {
      c = ' ';
    } else {
      c = ',';
    }

    printf("  %1.20fL,%1.20fL%c /* %3d */\n",
	   res_x,
	   res_y,
	   c,
	   i
	   );
  }
  printf("  };\n");
}

int main()
{
  rad();
  return 0;
}
