/** sym.c **/

#include <stdio.h>
#include <unistd.h>
#include <math.h>
#include <search.h>
#include <strings.h>
#include <ctype.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#include <gtk/gtk.h>
#include <gdk/gdk.h>

#include "qelem.h"
#include "points.h"
#include "manifold.h"
#include "myidle.h"
#include "scribble-simple.h"
#include "field.h"
#include "sym.h"

#define CP_TRACE

/* initialize from sym.dat */
void sym_init ( void )
{
  char wbuf[256];
  FILE *inf;
  char *c;
  POINT_PTR p;

  inf = fopen("sym.dat","r");
  if ( NULL == inf ) {
    printf("sym_init: no sym.dat\n");
    exit(1);
  }

  while ( fgets(wbuf,sizeof(wbuf),inf) ) {
    c = strchr(wbuf,'\n');
    if ( c ) {
      *c = 0;
    }

    c = wbuf;

    if ( *c == 0 ) {
      continue;
    }

    while ( isspace((int)*c) ) {
      c++;
    }

    switch ( *c )
      {
      case '#':
	continue;

      case 'y':
	c++;
	while ( isspace((int)*c) ) {
	  c++;
	}
	sscanf(c,"%lf",&n_const);
#ifdef CP_TRACE
	printf("sym_init: n_const set to %f\n",
	       n_const);
#endif
	break;

      case 'z':
	c++;
	while ( isspace((int)*c) ) {
	  c++;
	}
	sscanf(c,"%x",&trace_flag);
#ifdef CP_TRACE
	printf("sym_init: trace_flag set to 0x%x\n",
	       trace_flag);
#endif
	break;

      case 't':
	c++;
	while ( isspace((int)*c) ) {
	  c++;
	}
	sscanf(c,"%lf",&sym_inc);

#ifdef CP_TRACE
	printf("sym_init: sym_inc set to %f\n",
	       sym_inc);
#endif

	break;

      case 'c':
	c++;
	while ( isspace((int)*c) ) {
	  c++;
	}
	sscanf(c,"%lf",&waver_velosity);

#ifdef CP_TRACE
	printf("sym_init: waver_velosity set to %f\n",
	       waver_velosity);
#endif

	break;

      case 'g':
	c++;
	while ( isspace((int)*c) ) {
	  c++;
	}
	sscanf(c,"%lf",&strange_constant);

#ifdef CP_TRACE
	printf("sym_init: strange_constant set to %f\n",
	       strange_constant );
#endif

	break;

      case 'p':
	if ( pts_idx >= POINT_MAX ) {
	  printf("sym_init: too many points\n");
	  exit(1);
	}
	c++;
	while ( isspace((int)*c) ) {
	  c++;
	}
	p = &pts[pts_idx++];
	p->particle_number = pts_idx;
	sscanf(c,"%lf %lf %lf %lf %lf %x",
	       &p->x,&p->y,
	       &p->v_x, &p->v_y,
	       &p->mass,
	       &p->flag);

#ifdef CP_TRACE
	printf("sym_init: p%d x,y = [%f,%f], vx,vy = [%f,%f], m = %f\n",
	       pts_idx-1,
	       p->x,p->y,
	       p->v_x,p->v_y,
	       p->mass);
#endif

	break;

      default:
	printf("sym_init: unknown command line <%s>\n",
	       c);
	exit(1);
      }

  }


  fclose(inf);
}
